Subject: RE: bug#33870: 27.0.50; xref-goto-xref not configurable

From: Drew Adams <[email-masked]>
Date: Sun, 3 Feb 2019 21:02:07 +0000 (UTC)

> - Drew wrote something that I didn't read/understand
>   fully (sorry Drew!)

I added 4 side points related to points that came
up in the thread.  Possibly you didn't read or
understand one or more of them.  Enjoy.

1. "Everything in Emacs is (and should be) public."
   All `display-buffer*' functions deserve doc
   strings or at least developer-oriented comments.

2. Don't limit future use by having something like
   (direction . (DIR . WIN)).  Instead, as Juri
   suggested, use (direction DIR WIN), so you can
   easily later have (direction DIR WIN FOO), etc.

3. The mistake of #2 was made, e.g., when defining
   "noncontiguous region" segments: (BEG . END).
   A better design is (BEG END) or (BEG END . EXTRA),
   where EXTRA is from the outset undefined (any
   baggage).

4. All-encompassing DWIM for window selection and
   splitting is asking too much of Emacs.  Guessing
   the intention of a user or code in all contexts
   is bound to lose some of the time, frustrating
   users.  The code gets more and more complex,
   which doesn't help users guess what Emacs is
   guessing. ;-)  I'm glad I instead use separate
   frames, by default.